Attribute VB_Name = "Module1"
' Quellcode erstellt von Roland Berghfer
' bonit.at Software, Kollonitschgasse 11/2
' A-2700 Wiener Neustadt
' Internet: www.bonit.at www.riff.at

Public Declare Function ClewareInit Lib "usbaccess.dll" Alias "_FCWInitObject@0" () As Long
Public Declare Function ClewareUnInit Lib "usbaccess.dll" Alias "_FCWUnInitObject@4" (ByVal USBObject As Long) As Long
Public Declare Function ClewareOpen Lib "usbaccess.dll" Alias "_FCWOpenCleware@4" (ByVal USBObject As Long) As Long
Public Declare Function ClewareClose Lib "usbaccess.dll" Alias "_FCWCloseCleware@4" (ByVal USBObject As Long) As Long
Public Declare Function ClewareGetType Lib "usbaccess.dll" Alias "_FCWGetUSBType@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareStartDevice Lib "usbaccess.dll" Alias "_FCWStartDevice@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareGetSerial Lib "usbaccess.dll" Alias "_FCWGetSerialNumber@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareGetVersion Lib "usbaccess.dll" Alias "_FCWGetVersion@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareRecover Lib "usbaccess.dll" Alias "_FCWRecover@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareReset Lib "usbaccess.dll" Alias "_FCWResetDevice@8" (ByVal USBObject As Long, ByVal deviceNo As Integer) As Integer
Public Declare Function ClewareGetDLLVersion Lib "usbaccess.dll" Alias "_FCWGetDLLVersion@0" () As Long
Public Declare Function ClewareTemp Lib "usbaccess.dll" Alias "_FCWGetTemperature@16" (ByVal USBObject As Long, ByVal deviceNo As Integer, ByVal Temperature As Long, ByVal timeID As Long) As Integer
Public Declare Function ClewareHumidity Lib "usbaccess.dll" Alias "_FCWGetHumidity@16" (ByVal USBObject As Long, ByVal deviceNo As Integer, ByVal humidity As Long, ByVal timeID As Long) As Integer
Public Declare Function ClewareSetSwitch Lib "usbaccess.dll" Alias "_FCWSetSwitch@16" (ByVal USBObject As Long, ByVal deviceNo As Integer, ByVal Switch_ID As Integer, ByVal onoff As Integer) As Integer
Public Declare Function ClewareGetSwitch Lib "usbaccess.dll" Alias "_FCWGetSwitch@12" (ByVal USBObject As Long, ByVal deviceNo As Integer, ByVal SWITCH_IDs As Long) As Integer

Public USBObject As Long
Public DeviceCount As Integer
Public DeviceType As Integer
Public DeviceTypeString As String
Public SelectedSensor As Long

'Wir arbeiten mit maximal einem 4er Switch
Public Const SWITCH_0 = 16
Public Const SWITCH_1 = 17
Public Const SWITCH_2 = 18
Public Const SWITCH_3 = 19

'Typendeklaration fr die erkannten Sensoren
Public Type Sensorentype
    Seriennummer As Long
    Version As Variant
    Type As Integer
    Typestring As String
    Value As Double
    Realname_Short As String
    Realname_Long As String
    Enabled As Boolean
End Type


Public Sensoren(0 To 254) As Sensorentype

Public Sub Main()
    SelectedSensor = -1
    USBObject = ClewareInit()
    DeviceCount = ClewareOpen(USBObject)
    hauptform.Show 1
    erg = ClewareClose(USBObject)
    erg = ClewareUnInit(USBObject)
    End
End Sub
Public Sub inzwischen_sensorenlesen()
    erg = ClewareClose(USBObject)
    DeviceCount = ClewareOpen(USBObject)
    sensorenlesen
End Sub
Public Sub sensorenlesen()
    If DeviceCount > 0 Then
        For i = 0 To DeviceCount - 1
            DeviceTypeString = ""
            DeviceType = ClewareGetType(USBObject, i)
            If DeviceType = 40 Then DeviceTypeString = "USB Switch 4"
            If DeviceType = 16 Then DeviceTypeString = "USB Temp"
            If DeviceType = 32 Then DeviceTypeString = "USB Humidity"
            If DeviceType = 32 Then ClewareStartDevice USBObject, i
            Sensoren(i).Enabled = True
            Sensoren(i).Type = DeviceType
            Sensoren(i).Typestring = DeviceTypeString
            Sensoren(i).Seriennummer = ClewareGetSerial(USBObject, i)
            Sensoren(i).Version = ClewareGetVersion(USBObject, i)
        Next i
    End If
End Sub
Public Sub SwitchOn(Sensor As Long, device As Integer)
    'Schaltet einen Switch ein
    ClewareReset USBObject, Sensor
    warte 2
    Select Case device
    Case 1:
        ClewareSetSwitch USBObject, Sensor, SWITCH_0, 1
    Case 2:
        ClewareSetSwitch USBObject, Sensor, SWITCH_1, 1
    Case 3:
        ClewareSetSwitch USBObject, Sensor, SWITCH_2, 1
    Case 4:
        ClewareSetSwitch USBObject, Sensor, SWITCH_3, 1
    End Select
End Sub
Public Sub SwitchOff(Sensor As Long, device As Integer)
    'Schaltet einen Switch aus
    ClewareReset USBObject, Sensor
    warte 2
    Select Case device
    Case 1:
        ClewareSetSwitch USBObject, Sensor, SWITCH_0, 0
    Case 2:
        ClewareSetSwitch USBObject, Sensor, SWITCH_1, 0
    Case 3:
        ClewareSetSwitch USBObject, Sensor, SWITCH_2, 0
    Case 4:
        ClewareSetSwitch USBObject, Sensor, SWITCH_3, 0
    End Select
End Sub
Public Function ReadTemp(Sensor As Long) As Double
    'Hier wird die Temperatur des aktuellen Sensors ausgelesen
    'Die Funktion gibt entweder die Temperatur oder bei einem Fehler -1 zurck
    Dim temperatur As Double
    Dim zeit As Integer
    Dim Ptr_temperatur As Long
    Dim Ptr_zeit As Long
    Dim erg As Integer
    zeit = 0
    temperatur = 0
    Ptr_temperatur = VarPtr(temperatur)
    Ptr_zeit = VarPtr(zeit)
    zaehler = 0
nochmal:
    erg = ClewareTemp(USBObject, Sensor, Ptr_temperatur, Ptr_zeit)
    If erg = 0 Then
        erg = ClewareReset(USBObject, Sensor)
        warte 2
        zaehler = zaehler + 1
        If zaehler < 4 Then GoTo nochmal Else GoTo nochmal1
    End If
    ReadTemp = temperatur
    If zaehler = 4 Then ReadTemp = -1
    Exit Function
    
nochmal1:
    ClewareRecover USBObject, Sensor 'Verbindung zum Gert regenieren (falls diese abbricht)
    warte 2
    erg = ClewareReset(USBObject, Sensor)
    warte 2
    erg = ClewareTemp(USBObject, Sensor, Ptr_temperatur, Ptr_zeit)
    ReadTemp = temperatur
    If zaehler = 4 Then ReadTemp = -1
End Function
Public Function ReadHumidity(Sensor As Long) As Double
    'Hier wird die Temperatur des aktuellen Sensors ausgelesen
    'Die Funktion gibt entweder die Temperatur oder bei einem Fehler -1 zurck
    Dim humidity As Double
    Dim zeit As Integer
    Dim Ptr_humidity As Long
    Dim Ptr_zeit As Long
    Dim erg As Integer
    zeit = 0
    humidity = 0
    Ptr_humidity = VarPtr(humidity)
    Ptr_zeit = VarPtr(zeit)
    zaehler = 0
nochmal:
    erg = ClewareHumidity(USBObject, Sensor, Ptr_humidity, Ptr_zeit)
    If erg = 0 Then
        'erg = ClewareReset(USBObject, Sensor)
        'warte 2
        'erg = ClewareStartDevice(USBObject, Sensor)
        'warte 2
        zaehler = zaehler + 1
        If zaehler < 4 Then GoTo nochmal Else GoTo nochmal1
    End If
    ReadHumidity = humidity
    If zaehler = 4 Then ReadHumidity = -1
    Exit Function
    
nochmal1:
    'ClewareRecover USBObject, Sensor 'Verbindung zum Gert regenieren (falls diese abbricht)
    'warte 2
    'erg = ClewareReset(USBObject, Sensor)
    'warte 2
    'erg = ClewareStartDevice(USBObject, Sensor)
    'warte 2
    erg = ClewareHumidity(USBObject, Sensor, Ptr_humidity, Ptr_zeit)
    ReadHumidity = humidity
    If zaehler = 4 Then ReadHumidity = -1
End Function

Public Sub warte(zeit)
    dauer# = zeit / 3
    Start# = Timer   ' Anfangszeit setzen.
    Do While Timer < Start# + dauer#
        DoEvents    ' Steuerung an andere Prozesse
                    ' abgeben.
    Loop
End Sub

Public Function GetSwitch(Sensor As Long, Switch As Long) As Integer
    Dim switch1 As Long
    switch1 = 15 + Switch
    GetSwitch = ClewareGetSwitch(USBObject, Sensor, switch1)
End Function
